""" Util methods to bypass broken objects in ZODB due missing module/class

Code from: https://gist.github.com/704910

Also see: http://pypi.python.org/pypi/zodbupdate

"""
import imp
import sys

def create_modules(module_path):
    """ Create broken module
    """
    path = ""
    module = None
    for element in module_path.split('.'):
        path += element

        try:
            module = __import__(path)
        except ImportError:
            new = imp.new_module(path)
            if module is not None:
                setattr(module, element, new)
            module = new

        sys.modules[path] = module
        __import__(path)

        path += "."
    return module

def stub(module_path, class_name, base_class, meta_class=type):
    """ Stub out broken class
    """
    module = create_modules(module_path)
    setattr(module, class_name, base_class)

def migrate(self):
    # import known base class (or best match!)
    from Products.ATContentTypes.content.folder import ATFolder

    # stub out broken class
    stub('Products.MyOldBrokenProduct.SomeClass', 'SomeClass', ATFolder)

    # enjoy
    print self['some_old_site'].portal_old_broken_tool.valuable_data
